from pylab import plot,show
from numpy import vstack,array
from numpy.random import rand
from scipy.cluster.vq import kmeans,vq
import numpy as np

Radii = np.array([ 0.375, 0.55, 0.6, 0.25 ])

nClusters = 4
nRepeat = 250
tot = nClusters*nRepeat
Centers1 = tile([0,0], (nRepeat,1))
Centers2 = tile([3,3], (nRepeat,1))
Centers3 = tile([0,3], (nRepeat,1))
Centers4 = tile([3,0], (nRepeat,1))
Centers = np.concatenate((Centers1, Centers2, Centers3, Centers4))
xvalues1 =  tile(Radii[0], nRepeat)
xvalues2 =  tile(Radii[1], nRepeat)
xvalues3 =  tile(Radii[2], nRepeat)
xvalues4 =  tile(Radii[3], nRepeat)
Totradii = np.concatenate((xvalues1, xvalues2, xvalues3, xvalues4))
xrandom = np.random.randn(tot)
xrange = xrandom * Totradii
yrandom = np.random.randn(tot)
yrange = yrandom * Totradii
Points = np.column_stack((xrange, yrange))
data = Points + Centers

# computing K-Means with K = 2 (2 clusters)
centroids,_ = kmeans(data,2)
# assign each sample to a cluster
idx,_ = vq(data,centroids)

# some plotting using numpy's logical indexing
figure("Clustering K=2 Large Radius")
plot(data[idx==0,0],data[idx==0,1],'ob',
     data[idx==1,0],data[idx==1,1],'or')
plot(centroids[:,0],centroids[:,1],'sg',markersize=8)
show()


# computing K-Means with K = 4 (4 clusters)
centroids4,_ = kmeans(data,4)
# assign each sample to a cluster
idx4,_ = vq(data,centroids4)

# some plotting using numpy's logical indexing
figure("Clustering K=4 Large Radius")
plot(data[idx4==0,0],data[idx4==0,1],marker='o',markerfacecolor='blue', ls ='none')
plot(data[idx4==1,0],data[idx4==1,1],marker='o',markerfacecolor='red', ls ='none')
plot(data[idx4==2,0],data[idx4==2,1],marker='o',markerfacecolor='orange', ls ='none')
plot(data[idx4==3,0],data[idx4==3,1],marker='o',markerfacecolor='purple', ls ='none')
plot(centroids4[:,0],centroids4[:,1],'sg',markersize=8)
show()

Radii = 0.25*Radii
xvalues1 =  tile(Radii[0], nRepeat)
xvalues2 =  tile(Radii[1], nRepeat)
xvalues3 =  tile(Radii[2], nRepeat)
xvalues4 =  tile(Radii[3], nRepeat)
Totradii = np.concatenate((xvalues1, xvalues2, xvalues3, xvalues4))
xrandom = np.random.randn(tot)
xrange = xrandom * Totradii
yrandom = np.random.randn(tot)
yrange = yrandom * Totradii
Points = np.column_stack((xrange, yrange))
data = Points + Centers

# computing K-Means with K = 2 (2 clusters)
centroids,_ = kmeans(data,2)
# assign each sample to a cluster
idx,_ = vq(data,centroids)


# some plotting using numpy's logical indexing
figure("Clustering K=2 Small Radius")
plot(data[idx==0,0],data[idx==0,1],'ob',
     data[idx==1,0],data[idx==1,1],'or')
plot(centroids[:,0],centroids[:,1],'sg',markersize=8)
show()


# computing K-Means with K = 4 (4 clusters)
centroids4,_ = kmeans(data,4)
# assign each sample to a cluster
idx4,_ = vq(data,centroids4)

# some plotting using numpy's logical indexing
figure("Clustering K=4 Small Radius")
plot(data[idx4==0,0],data[idx4==0,1],marker='o',markerfacecolor='blue', ls ='none')
plot(data[idx4==1,0],data[idx4==1,1],marker='o',markerfacecolor='red', ls ='none')
plot(data[idx4==2,0],data[idx4==2,1],marker='o',markerfacecolor='orange', ls ='none')
plot(data[idx4==3,0],data[idx4==3,1],marker='o',markerfacecolor='purple', ls ='none')
plot(centroids4[:,0],centroids4[:,1],'sg',markersize=8)
show()

Radii = 6*Radii
xvalues1 =  tile(Radii[0], nRepeat)
xvalues2 =  tile(Radii[1], nRepeat)
xvalues3 =  tile(Radii[2], nRepeat)
xvalues4 =  tile(Radii[3], nRepeat)
Totradii = np.concatenate((xvalues1, xvalues2, xvalues3, xvalues4))
xrandom = np.random.randn(tot)
xrange = xrandom * Totradii
yrandom = np.random.randn(tot)
yrange = yrandom * Totradii
Points = np.column_stack((xrange, yrange))
data = Points + Centers

# computing K-Means with K = 2 (2 Very Large clusters)
centroids,_ = kmeans(data,2)
# assign each sample to a cluster
idx,_ = vq(data,centroids)

# some plotting using numpy's logical indexing
figure("Clustering K=2 Very Large Radius")
plot(data[idx==0,0],data[idx==0,1],'ob',
     data[idx==1,0],data[idx==1,1],'or')
plot(centroids[:,0],centroids[:,1],'sg',markersize=8)
show()


# computing K-Means with K = 4 (4 Very Large clusters)
centroids4,_ = kmeans(data,4)
# assign each sample to a cluster
idx4,_ = vq(data,centroids4)

# some plotting using numpy's logical indexing
figure("Clustering K=4 Very Large Radius")
plot(data[idx4==0,0],data[idx4==0,1],marker='o',markerfacecolor='blue', ls ='none')
plot(data[idx4==1,0],data[idx4==1,1],marker='o',markerfacecolor='red', ls ='none')
plot(data[idx4==2,0],data[idx4==2,1],marker='o',markerfacecolor='orange', ls ='none')
plot(data[idx4==3,0],data[idx4==3,1],marker='o',markerfacecolor='purple', ls ='none')
plot(centroids4[:,0],centroids4[:,1],'sg',markersize=8)
show()